freeslot("S_PYF_POOKADUG", "S_PYF_KILLERINSTINCT")

freeslot()

local pyfollow = {}

pyfollow.ki_callouts = {
	"sfx_pyf8ka",
	"sfx_pyf8kb",
	"sfx_pyf8kc",
	"sfx_pyf8kd",
	"sfx_pyf8ke",
	"sfx_pyf8kf",
	"sfx_pyf8kg",
	"sfx_pyf8kh",
	"sfx_pyf8ki",
	"sfx_pyf8kj",
	"sfx_pyf8kk",
	"sfx_pyf8kl",
	"sfx_pyf8km",
	"sfx_pyf8kn",
	"sfx_pyf8ko",
	"sfx_pyf8kp",
	"sfx_pyf8kz"
}

freeslot("sfx_pyf8r1", "sfx_pyf8r2")
freeslot("sfx_pyf8s1", "sfx_pyf8s2", "sfx_pyf8s3", "sfx_pyf8s4")
freeslot("sfx_pyf8f1", "sfx_pyf8f2")

freeslot("sfx_pyf8d1", "sfx_pyf8d2")

for _, snd in ipairs(pyfollow.ki_callouts) do
	freeslot(snd)
end

pyfollow.thinks = {}
pyfollow.damages = {}

--============================================================================--
--============================================================================--
--============================================================================--
--============================================================================--

-- Pooka

pyfollow.thinks[S_PYF_POOKADUG] = function(mo)
	if ( mo.momz > 0 ) then
		mo.frame = 0
	else
		mo.frame = 1
	end
end

-- Killer Instinct

pyfollow.thinks[S_PYF_KILLERINSTINCT] = function(mo)
	if not ( mo.target and mo.target.valid and mo.target.player and mo.target.player.valid ) then return end
	
	if not mo.py_saidfight and leveltime >= starttime then
		if starttime > 1 then
			S_StartSound(nil, sfx_pyf8r2)
		end
		mo.py_saidfight = true
	end
	
	if not mo.py_saidready and leveltime >= starttime-105 then
		if not mo.py_saidfight and starttime > 1 then
			S_StartSound(nil, sfx_pyf8r1)
		end
		mo.py_saidready = true
	end
	
	if not mo.py_lastlaps then
		mo.py_lastlaps = mo.target.player.laps
	end
	if mo.target.player.laps > mo.py_lastlaps then
		if mo.target.player.exiting then
			if mo.target.player.position == 1 then
				local targ = mo.target
				if consoleplayer == mo.target.player then
					targ = nil
				end
				if leveltime % 2 == 0 then
					S_StartSound(targ, sfx_pyf8f1)
				else
					S_StartSound(targ, sfx_pyf8f2)
				end
			end
		else
			if mo.target.player.position == 1 then
				S_StartSound(mo.target, sfx_pyf8s1)
			elseif mo.target.player.position == 2 then
				S_StartSound(mo.target, sfx_pyf8s4)
			elseif mo.target.player.position == 3 then
				S_StartSound(mo.target, sfx_pyf8s3)
			elseif mo.target.player.position <= 5 then
				S_StartSound(mo.target, sfx_pyf8s2)
			end
		end
		mo.py_lastlaps = mo.target.player.laps
	end
	
	--print(mo.target.player.position)
	
	if mo.target.player.rings <= -20 then
		if mo.py_danger == false then
			mo.py_danger = true
			if leveltime % 2 == 0 then
				S_StartSound(targ, sfx_pyf8d1)
			else
				S_StartSound(targ, sfx_pyf8d2)
			end
		end
	else
		mo.py_danger = false
	end
	
	if mo.py_combowait and mo.py_combowait < leveltime then
		mo.py_combo = mo.py_combo-1
		if mo.py_combo > 0 then
			S_StartSound(nil, _G[pyfollow.ki_callouts[min(mo.py_combo,#pyfollow.ki_callouts)]])
		end
		mo.py_combowait = nil
		mo.py_combo = 0
		--print(pyfollow.ki_callouts[1])
	end
end

pyfollow.damages[S_PYF_KILLERINSTINCT] = function(mo)
	mo.py_combowait = leveltime + 50
	
	if mo.py_combo then
		mo.py_combo = mo.py_combo + 1
	else
		mo.py_combo = 1
	end
		
	--print("COMBO! "+mo.py_combo)
end

--============================================================================--
--============================================================================--
--============================================================================--
--============================================================================--

-- for players...

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if not ( source and source.player and source.player.valid and source.player.follower and source.player.follower.valid ) then return end
	if not pyfollow.damages[source.player.follower.state] then return end 
	pyfollow.damages[source.player.follower.state](source.player.follower)
end, MT_PLAYER)

-- for prisons too...

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if not ( source and source.player and source.player.valid and source.player.follower and source.player.follower.valid ) then return end
	if not pyfollow.damages[source.player.follower.state] then return end 
	pyfollow.damages[source.player.follower.state](source.player.follower)
end, MT_BATTLECAPSULE)

addHook("MobjThinker", function(mo)
	if not pyfollow.thinks[mo.state] then return end 
	pyfollow.thinks[mo.state](mo)
end, MT_FOLLOWER)